#!/usr/bin/env python

#
#gooload.py
#
#Copyright (C) 2008 Irae Hueck Costa
#   
#This file is part of Golooad.
#
#Gooload is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#Gooload is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Gooload.  If not, see <http://www.gnu.org/licenses/>.
#
#




import urllib2
from shutil import move
import threading
import tempfile
from time import sleep
import re
from urllib import urlencode, unquote_plus, quote
from urlparse import urlunsplit, urlsplit
from xml.sax.saxutils import unescape as html_unescape
import os
from xml.parsers import expat
import sys

#if os.name == 'nt':
#	print 'system is windows. installing win32eventreactor...'
#	from twisted.internet import win32eventreactor
#	win32eventreactor.install()
#else:
#	print "using the selectreactor"
from twisted.internet import reactor

#from twisted.web.client import getPage
from twisted.internet import tksupport
from twisted.web.client import _parse, HTTPClientFactory #for http_head
from twisted.web import soap


#for the regex
WORD_SEPARATORS = (' ', '.', '_', '-')

user_agent = "Mozilla/5.001 (windows; U; NT4.0; en-us) Gecko/25250101"
#user_agent = 'Gooload 0.8 BETA'
search_engine = 'yahoo'
yahoo_appid = 'gooload'
msn_appid = '1B9ABBC28AC55D91AAC7010868E79AE994756DAA'
on_active_conns_chg = lambda: 0

google_re = re.compile('<a href="(\w*://[^"]*)" class=l>')
progress_cb = lambda n: 0


def set_user_agent(new_val):
	global user_agent
	user_agent = new_val
def set_search_engine(new_val):
	global search_engine
	search_engine = new_val
#def set_on_active_conns_chg(new_val):
#	global on_active_conns_chg
#	on_active_conns_chg = new_val
#def set_stdout(cb):
#	class T(object): pass
#	T.write = cb
#	sys.stdout = T
#def set_stderr(cb):
#	class T(object): pass
#	T.write = cb
#	sys.sterr = T

def mk_files_re(keyword, filetypes_accept):
	
	print "generating regex"
	
	#todo: comment and optimize this lines
	word_separators_re = "(?:" + "|".join((re.escape(quote(i)) for i in WORD_SEPARATORS)) + ")"
	keyword = quote(keyword)
	
	# ``'`` seems not be quoted so undo quotes on ``'``
	keyword = keyword.replace(quote("'"), "'")
	
	keyword = keyword.replace(quote(" "), word_separators_re)
	myre = '<a href="(.*?' + keyword + '.*?\.(?:' + '|'.join(re.escape(quote(i)) for i in filetypes_accept)  +'))".*?>'
	
	print "re generated:", repr(myre)
	return re.compile(myre, re.IGNORECASE)
	
def mk_query(keyword, filetype):
	return 'intitle:"index of" intext:"server at" intext:"%s" intext:".%s"' % (keyword, filetype)

def cut_params(url):
	return urlunsplit(list(urlsplit(url)[:3]) + ['']*2)

def octet2megabytes(octets):
	return round(octets/1000000.0, 2)

class ConnsManager(object):
	def __init__(self):
		self.conns = []
		self.num_conns = 0
	
	def append_conn(self, what):
		self.conns.append(what)
		self.num_conns += 1

	def remove_conn(self, what):
		self.num_conns -= 1

	def close_all(self):
		print "closing all connections"
	
		global searching
		searching = False
		
		while self.conns:
			connector = self.conns.pop()
			print "closing connection to:", connector.getDestination()
			connector.disconnect()
		self.conns = []
		self.numm_conns = 0

conns_manager = ConnsManager()


def http_head(url, cb):
	
	if not searching:
		print "not heading", url
		return

	#todo: tell the progress valuer about conns chg
	#too hacky. is perhaps not working well
	scheme, host, port, path = _parse(url)
	factory = HTTPClientFactory(url, method='HEAD')
	if scheme == 'https':
		from twisted.internet import ssl
		contextFactory = ssl.ClientContextFactory()
		connector = reactor.connectSSL(host, port, factory, contextFactory)
	else:
		connector = reactor.connectTCP(host, port, factory)
	conns_manager.append_conn(connector)
	factory.deferred.addBoth(lambda resp:
							conns_manager.remove_conn(connector) or \
							cb(getattr(factory, "status", None), factory.response_headers))

	
def http_get(url, callback, retry=False,
			contextFactory=None, *args, **kwargs):
	
	if not searching:
		print 'not fetching:', url
		return
	
	#based on twisted.web.GetPage!
	from twisted.web.client import HTTPClientFactory
	from twisted.web.client import _parse
	scheme, host, port, path = _parse(url)
	factory = HTTPClientFactory(url, agent=user_agent, *args, **kwargs)
	if scheme == 'https':
		from twisted.internet import ssl
		if contextFactory is None:
			contextFactory = ssl.ClientContextFactory()
		connector = reactor.connectSSL(host, port, factory, contextFactory)
	else:
		connector = reactor.connectTCP(host, port, factory)
	
	conns_manager.append_conn(connector)
	factory.deferred.addCallback(callback=lambda resp: conns_manager.remove_conn(connector) or callback(resp))
	
	def try_again(err):
		#this will cause a StackError after a while and sends too much request too the server
		#sleep not possible , because the twisted mainloop would be interrupted
		print 'http_get: retrying to fetch', url, 'error was:', str(err)
			
		http_get(url, callback, True)
	
	def errback(err):
		pass
		#print("Error fetching " + url + 'error was: ' + str(err))
	
	if retry:
		factory.deferred.addErrback(lambda err: conns_manager.remove_conn(connector) or errback(err) or try_again(err))
	else:
		factory.deferred.addErrback(lambda err: conns_manager.remove_conn(connector)  or errback(err))



#===Yahoo===

class YahooXMLHandler(object):
	def __init__(self):
		
		self.parser = expat.ParserCreate()
		self.parser.StartElementHandler = self._start_element
		self.parser.EndElementHandler = self._end_element
		self.parser.CharacterDataHandler = self._char_data
		
		self.buffer = "" # evtl schneller, wenn buffer eine liste oder cStringIO ist
		self.annotate = False
		self.in_cache = False
		self.payload = []
	def _start_element(self, name, attrs):
		if name == "Url" and not self.in_cache:
			self.annotate = True
		elif name == "ResultSet":
			self.in_ResultSet = True
			self.payload.append(int(attrs["totalResultsAvailable"]))
		elif name == 'Cache':
			self.in_cache = True

	def _end_element(self, name):
		if name == "Url" and not self.in_cache:
			self.annotate = False
			
			url = cut_params(str(self.buffer))
			self.payload.append(url)
			
			self.buffer = ""
		elif name == 'Cache':
			self.in_cache = False

	def _char_data(self, data):
		if self.annotate:
			self.buffer += data
	
	def handle(self, xmlstr):
		#ist 1 richtig?
		self.parser.Parse(xmlstr, 1)
		return self.payload.pop(0), self.payload
def yahoo_parse_resp(xmlresp):
	yahoo_xh = YahooXMLHandler()
	num, urls = yahoo_xh.handle(xmlresp)
	return num, set(urls)

def yahoo_get_resp_by_page(keyword, page, cb):
	print("Requesting the page #" + str(page) + ' on Yahoo for "' + keyword + '"')
	url = 'http://search.yahooapis.com/WebSearchService/V1/webSearch?' + urlencode(dict(appid=yahoo_appid, query=keyword, start=page*100+1, results=100))
	http_get(url, callback=cb, retry=True)

def yahoo_get_urls(keyword, url_cb):
	def handle_resp(resp, first_call=False):
		num_urls_found, urls = yahoo_parse_resp(resp)
		if first_call:
			
			#fixme: handle more than 800 urls better than just taking the first 800
			#(the problem is twisted can not .update the root, when there are too many connections)
			if num_urls_found > 800:
				#progress_valuer.will_get_conns(800)
				pages2get = range(8)
			else:
				#progress_valuer.will_get_conns(num_urls_found)
				pages2get = range(num_urls_found/100 + (1 if num_urls_found%100 else 0))
			
			for page_nr in pages2get:
				yahoo_get_resp_by_page(keyword, page_nr, handle_resp)
	
		for url in urls:
			url_cb(cut_params(url))
	yahoo_get_resp_by_page(keyword, 0, lambda resp: handle_resp(resp, True))
#===end Yahoo===


#===MSN===

msn_soap_conn = soap.Proxy("http://soap.search.msn.com/webservices.asmx?wsdl")
def msn_get_urls_by_page(keyword, page, urls_cb):
	print("Requesting the page #" + str(page) + ' on MSN for "' + keyword + '"')
	def resp_cb(server_resp):
		results =  server_resp.Responses[0].Results
		if results:
			urls_cb(set([cut_params(res["Url"]) for res in results[0]]))
		else:
			print("got no results for a msn search")

	params = {'AppID': msn_appid,
	'Query': keyword,
	'CultureInfo': 'en-US',
	'SafeSearch': 'Off',
	'Requests': {
	'SourceRequest':{
	'Source': 'Web',
	'Offset': page*50,
	'Count': 50,
	'ResultFields': 'All',
	}}
	}
	msn_soap_conn.callRemote('Search', Request=params).addCallbacks(callback=resp_cb,
														errback=lambda: msn_get_urls_by_page(keyword, page, urls_cb)) #hmm....

def msn_get_urls(keyword, url_cb):
	def urls_cb(urls, page):
		if urls:
			msn_get_urls_by_page(keyword, page+1, lambda urls: urls_cb(urls, page+1))
			for url in urls:
				url_cb(url)
	msn_get_urls_by_page(keyword, 0, lambda urls: urls_cb(urls, 0))

#===end MSN===


#===Google===

def google_get_resp(keyword, pagenr, callback):
	url = "http://www.google.com/search?" + urlencode(dict(q=keyword, start=pagenr*100, num=100, filter="off"))
	http_get(url, callback, retry=True)

def google_get_urls_by_page(keyword, pagenr, urls_cb):
	print("Requesting the page #" + str(pagenr) + ' on Google for "' + keyword + '"')
	def handle_resp(resp):
		urls = set(cut_params(url) for url in google_re.findall(resp))
		urls_cb(urls)
	google_get_resp(keyword, pagenr, handle_resp)

def google_get_urls(keyword, url_cb):
	def handle_urls(urls, page_nr, prev_urls=None):
		if prev_urls != urls:
			for url in urls:
				url_cb(url)
			google_get_urls_by_page(keyword, page_nr+1, lambda new_urls: handle_urls(new_urls, page_nr+1, urls))
		else:
			print 'Requested all google pages. total:', page_nr-1+1
	handle_urls([], -1)

#===end Google===


def search_for_files(keyword, filetype_search, filetypes_accept, file_cb):
	
	global searching
	searching = True
	
	files_re = mk_files_re(keyword, filetypes_accept)
	search_for = mk_query(keyword, filetype_search)
	print 'searching for:', search_for
	print('Searching for "' + search_for + '" on ' + search_engine)
	
	def handle_found_file(location, pretty_filename, status, header):
		#print 'header:', header
		#if file found or unknown http response status call the cb
		if str(status).startswith('2') or status is None:
			if header is not None and header.get('content-length') is not None:
				size = octet2megabytes(int(header['content-length'][0]))
			else:
				size = '?'
			#print 'cbing file:', location, pretty_filename, size
			if searching:
				file_cb(location, pretty_filename, size)
		else:
			print('File ' + pretty_filename + ' seems to not exist )-;')
	
	def handle_url(url):
		#print 'got', url
		http_get(url, lambda resp: handle_resp(url, resp))
	
	def handle_resp(url, resp):
		files = files_re.findall(resp)
		print('Found ' + str(len(files)) + ' files on ' + url)
		
		#print files
		#print resp
		
		for file in files:
			
			#files with absolute paths and so on are not handled specially, just discarded (fixme?)
			if '/' in file:
				#print 'ignoring:', file
				continue
			
			#is this way ok?
			pretty_filename = unquote_plus(unquote_plus(html_unescape(file)))
			
			location = os.path.join(url, file)
			http_head(location, lambda status, header, l=location, p=pretty_filename: handle_found_file(l, p, status, header))
	
	if search_engine == 'google':
		google_get_urls(search_for, handle_url)
	elif search_engine == 'yahoo':
		yahoo_get_urls(search_for, handle_url)
	elif search_engine == 'msn':
		
		#msn use "inbody" instead of "intext" (this solution is a little dirty?)
		search_for = search_for.replace('intext:', 'inbody:')
		
		msn_get_urls(search_for, handle_url)
	else:
		assert False
	

def _download(from_, to, as_, progress_cb):
		print "Downloading", from_
		try:
			req = urllib2.Request(from_)
			req.add_header('User-Agent', user_agent)
			conn = urllib2.urlopen(req)
			
			content_len = conn.info().get('Content-length')
			tmp_file = file(os.path.join(tempfile.gettempdir(), as_), 'wb')
			if not content_len:
				progress_cb('?%')
				for chunk in conn:
					tmp_file.write(chunk)
			else:
				content_len = int(content_len)
				arived_len = 0.0
				last_progress = None
				for chunk in conn:
					arived_len += len(chunk)
					progress = int(100*arived_len/content_len)
					if progress != last_progress:
						progress_cb(str(progress) + '%')
					last_progress = progress
					tmp_file.write(chunk)
					last_progress = progress
			tmp_file.close()

			progress_cb("moving")
			move(tmp_file.name, to)
			progress_cb('pwned!')

		except Exception, exc:
			progress_cb('error - ' + str(exc))
			#raise exc

def download(from_, to, as_, progress_cb):
	threading.Thread(target=_download, args=(from_, to, as_, progress_cb)).start()







	



